﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGDataTable
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ViewModel vm { get; set; }   
        public MainWindow()
        {
            InitializeComponent();
            this.vm = new ViewModel();
            this.DataContext = vm;
            this.xdg.FieldLayoutSettings.AutoGenerateFields = false;
          
            this.xdg.FieldSettings.AllowRecordFiltering = true;
            Binding dataBinding = new Binding();
            dataBinding.Source = vm.Data;
            this.xdg.SetBinding(XamDataGrid.DataSourceProperty, dataBinding);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            LabelPresenter labelPresenter = (LabelPresenter)Infragistics.Windows.Utilities.GetAncestorFromType((Button)sender, typeof(LabelPresenter), false);
            if(labelPresenter == null)
            {
                return;          
            }
            Field field = labelPresenter.Field;
            // either remove the field - irrevirsible
            //this.xdg.FieldLayouts[0].Fields.Remove(field);
            // or hide it and allow it to be turned back form the Field Chooser
            field.Visibility = Visibility.Collapsed;
        }

        private void xdg_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            // Data is a DataTable
            foreach (DataColumn column in this.vm.Data.Columns)
            {
              
                ComboBoxField field = new ComboBoxField
                {
                    Name = column.ColumnName,
                    ItemsSource = this.vm.ComboOptions
                };
                e.FieldLayout.Fields.Add(field);
            }
           
        }
    }
}
